Skip to main content

Two State Button

The Two State Button control is a special button variation that has two states: unpressed and pressed. You can add a click handler for a button, change the button's state, provide separate content for the pressed and unpressed states, set an appropriate button's type and make a button disabled whenever you need it.

TwoState Button

Initialization

To create an instance of the Two State button on a page (React), you need to complete the following steps:

  • import the component in your file:
App.jsx
import { TwoState } from "@svar-ui/react-core";
  • use the <TwoState> element to initialize the control:
App.jsx
export default function App() {
return <TwoState>Click Me</TwoState>;
}

Setting the value

By default, Two State button is initialized in the unpressed state. To enable the pressed state of the button, set the value property to true:

<TwoState value={true}>
Click me
</TwoState>

Setting different content for each state

You can provide different content for the default (unpressed) and the pressed states of Two State button:

  • for the unpressed state, specify the text property
  • for the pressed state, specify the textActive property
<TwoState text="Click me" textActive="Working..." />

TwoState Button

It is possible to use different icons for both states of the button. Read more in the Adding icons into buttons section.

Related sample: Two State Button

Getting the current state

You can get the current state of the Two State button using React state. For this:

  • create a state variable that will contain the value of the button (it may contain the initial value):
import { useState } from "react";
import { TwoState } from "@svar-ui/react-core";

export default function App() {
const [state, setState] = useState(true);

return <TwoState value={state} onChange={({ value }) => setState(value)} />;
}

Catching the change of the button state

To catch when a button is pressed or unpressed, handle the change event. The handler receives an object with the state of the button:

function handleChange({ value }) {
console.log(value);
}

<TwoState onChange={handleChange} />

The handler function for the change event receives an object where value is true (pressed) or false (unpressed).

Specifying the appearance of a button

Specify the desired look and feel of a Two State button by setting the corresponding type via the type property.

<TwoState type={'primary'}>Click Me</TwoState>

The Two State Button control inherits its types from SVAR Button. The list below provides the available types of the Two State Button.

  • 'default'

TwoState default

  • 'primary'

TwoState primary

  • 'secondary'

TwoState secondary

  • 'danger'

TwoState danger

  • 'link' (can have an icon and be disabled as well as a standard button)

TwoState link

Related sample: Two State Button

Using a button block

There is a special button type that you can use if you need a button to span the full width of its parent. It is called a button block and has two sub-types:

  • 'primary block' (has the primary styling)

TwoState primary block

  • 'secondary block' (has the secondary styling)

TwoState secondary block

Related sample: Two State Button

Handling a button click

To add a click handler function to your button, use the click event (React: onClick).

Click handler

function myFunction() {
// some custom logic
}

<TwoState onClick={myFunction}>Click Me</TwoState>

Showing a message on click

SVAR provides an extended messaging system to implement user-app communication. A common case for a button click is showing a notice or a dialog. You can use the library helpers from context with React's useContext to display a message box while handling a Two State button click.

Example using the showNotice helper:

import { useContext } from "react";
import { context } from "@svar-ui/react-core";
import { TwoState } from "@svar-ui/react-core";

export default function App() {
// getting the helper from shared context
const { showNotice } = useContext(context.helpers);

// add a handler function
function handleClick() {
// using the helper to show a message
showNotice({
text: "Two State Button is clicked",
});
}

return (
<div>
{/* calling the function on a two state button click */}
<TwoState onClick={handleClick}>Click Me</TwoState>
</div>
);
}

Related sample: Two State Button

You can read detailed information on Messages in the Guides.

Making a button inactive

You can make a button unclickable by preventing the default click handling via the click handler. Call the preventDefault() method of the Event interface inside the handler function:

<TwoState onClick={ev => ev.preventDefault()}>
Click me
</TwoState>

Inactive state

Related sample: Two State Button

Setting the disabled state

Render a disabled Two State button with the disabled property. You can either set the property to true or use the property name without a value (JSX interprets presence as true):

<TwoState disabled={true}>Click me</TwoState>

or

<TwoState disabled>Click Me</TwoState>

TwoState disabled

Related sample: Two State Button

Adding a title

A title is a tooltip text that appears when hovering the mouse cursor over a button and may contain extra information about the control. Use the title property to add a tooltip:

<TwoState title="Click me and I will change my state">Click Me</TwoState>

Two State Button with a title

Related sample: Two State Button

Styling a button

You can add a custom style to the Two State button control. Provide the desired CSS in your stylesheet and set the name of the custom class as a value of the css property in the component's props.

<TwoState type={'primary'} css="my">
Click Me
</TwoState>

Example CSS (global stylesheet):

/* styling the button in the default state */
button.my {
background-color: gold;
color: white;
}

/* styling the button in the pressed state */
button.pressed {
background-color: lightgrey;
color: white;
}

In the above example the selector includes the HTML element ("button") to be specific for the underlying element rendered by the control. Adjust selectors to match how the TwoState component renders markup in your environment.

Styling a pressed button

To change the style of a button in the pressed state, add the .pressed selector for the button and provide the desired style attributes for it (see CSS above).

Here's how the stylized Two State button looks like:

Two State button custom style

Adding icons into buttons

You can add icons into a Two State button. The name of a default icon starts with the wxi- prefix. Examples of using icons in different types of Two State buttons, both with and without text:

// an icon button with a text
<TwoState icon="wxi-alert">With Icon</TwoState>
<TwoState type={'primary'} icon="wxi-alert" iconActive="wxi-check">With Icon</TwoState>
<TwoState type={'secondary'} icon="wxi-alert">With Icon</TwoState>

// an icon button without a text
<TwoState icon="wxi-alert" />
<TwoState type={'primary'} icon="wxi-alert" />
<TwoState type={'secondary'} icon="wxi-alert" />
<TwoState type={'danger'} icon="wxi-alert" />

// a disabled icon button
<TwoState disabled icon="wxi-alert" />

Icon buttons

Using the default icon pack

The default icons' set is based on the Material Design icons' collection. The list of predefined icons is presented in the snippet. This list is being constantly replenished with new icons.

To use the default icons' pack on a page, include the pack in your HTML:

<link rel="stylesheet" href="https://cdn.svar.dev/fonts/wxi/wx-icons.css" />

Then use the icon property to specify the desired icon name; default icon names are formed as wxi-name:

<TwoState icon="wxi-alert">Click Me</TwoState>

Related sample: Two State Button

Setting an icon for the pressed state

Besides the icon for the default state, Two State Button can have a special icon for the pressed state. Use the iconActive property to set the pressed-state icon:

<TwoState icon="wxi-alert" iconActive="wxi-check">With Icon</TwoState>

Icon active

Related sample: Two State Button

Customizing the appearance of an icon

You can change the appearance of an icon by wrapping it in an <i> tag and using its style attribute. Example:

<TwoState type={'primary'}>
<i className="wxi-alert" style={{ color: "yellow" }} />
With Icon
</TwoState>

Two State Button
The Two State Button control is a special button variation that has two states: unpressed and pressed. You can add a click handler for a button, change the button's state, provide separate content for the pressed and unpressed states, set an appropriate button's type and make a button disabled whenever you need it.
Related resources
- Get the widget by installing the
@svar-ui/vue-corepackage. - Check Two State Button API Reference to see the list of configuration properties.
- Explore the samples to visualize the available features.
Initialization
To create an instance of the Two State button on a page, you need to complete the following steps:
- import the source file of the control on a page:
<script setup>
import { TwoState } from "@svar-ui/vue-core";
</script>
- use the
<TwoState>tag to initialize the control:
<template>
<TwoState>Click Me</TwoState>
</template>
Setting the value
By default, Two State button is initialized in the unpressed state. To enable the pressed state of the button, you should set the value property to true:
<TwoState :value="true">
Click me
</TwoState>
Setting different content for each state
You can provide different content for the default (unpressed) and the pressed states of Two State button:
- for the unpressed state, specify the
textproperty - for the pressed state, specify the
textActiveproperty
<TwoState text="Click me" textActive="Working..."/>
It is possible to use different icons for both states of the button. Read more in the Using icons section.
Related sample: Two State Button
Getting the current state
It is possible to get the current state of the Two State button. For this, you need:
- specify a variable that will contain the value of the button (it may contain the initial value):
<script setup>
import { ref } from "vue";
import { TwoState } from "@svar-ui/vue-core";
const state = ref(true);
</script>
- bind the variable to the
valueproperty of the control:
<template>
<TwoState v-model:value="state" />
</template>
After that the value assigned to the bound variable will be updated on each change of the button's state.
Catching the change of the button state
In case you need to catch when a button is pressed or unpressed, you can do it by handling the change event. Inside the event you can get the value of the button state in the following way:
<script setup>
function handleChange({value}){
console.log(value);
}
</script>
<template>
<TwoState :onchange="handleChange"/>
</template>
The handler function of the change event takes an object with the state of a button which is "true" (pressed) or "false" (unpressed).
Specifying the appearance of a button
You can specify the desired look and feel of a Two State button by setting the corresponding type. The type of the Two State button is defined by the type property.
<TwoState type="primary">Click Me</TwoState>
The Two State Button control inherits its types from SVAR Button. The list below provides the available types of the Two State Button.
'default'
'primary'
'secondary'
'danger'
'link'(can have an icon and be disabled as well as a standard button)
Related sample: Two State Button
Using a button block
There is a special button type that you can use if you need a button to span the full width of its parent. It is called a button block and has two sub-types:
'primary block'(has the primary styling)
'secondary block'(has the secondary styling)
Related sample: Two State Button
Handling a button click
To add a click handler function to your button, make use of the click event.
<script setup>
function myFunction() {
// some custom logic
}
</script>
<template>
<TwoState :onclick="myFunction">Click Me</TwoState>
</template>
Showing a message on click
SVAR provides an extended messaging system to implement user-app communication. Since one of the most common cases for a button click is a call of a notice or a dialog box, you can use the library helpers to create a suitable message box while handling a Two State button click.
For example, you can use the showNotice() helper to display a message:
<script setup>
import { TwoState } from "@svar-ui/vue-core";
import { inject } from "vue";
// getting the helper
const { showNotice } = inject("wx-helpers");
// then add a handler function
function onclick() {
// using the helper to show a message
showNotice({
text: "Two State Button is clicked",
});
}
</script>
<template>
<div>
<!-- calling the function on a two state button click -->
<TwoState :onclick="onclick">Click Me</TwoState>
</div>
</template>
Related sample: Two State Button
You can read detailed information on Messages in the Guides.
Making a button inactive
You can make a button unclickable, if needed. For this, you need to prevent the default click handling via the click handler. Call the preventDefault() method of the Event interface inside the handler function:
<TwoState :onclick="ev => ev.preventDefault()">
Click me
</TwoState>
Related sample: Two State Button
Setting the disabled state
Whenever you need to render a disabled Two State button, you can do it with the help of the disabled property. You can either set the property to true or use the property name without a value:
<TwoState :disabled="true">
Click me
</TwoState>
It is also possible to specify the disabled property without a value:
<TwoState disabled>Click Me</TwoState>
Related sample: Two State Button
Adding a title
A title is a tooltip text that appears on hovering the mouse cursor over a button and may contain some extra information about the control. Use the title property to add a tooltip for a button:
<TwoState title="Click me and I will change my state">Click Me</TwoState>
Related sample: Two State Button
Styling a button
You can add a custom style to the Two State button control. You need to provide the desired settings in the style section of the application and set the name of the custom class as a value of the css property in the control's tag.
<template>
<div class="demo-box">
<TwoState type="primary" css="my" :onclick="onclick">Click Me</TwoState>
</div>
</template>
<style scoped>
/* styling the button in the default state */
.demo-box :deep(button.my){
background-color: gold;
color:white;
}
</style>
In the above example the style is set using :deep() in order to reach an isolated button control. To make the selector specific for the button, the name of the HTML element ("button") is also set before the class name.
Styling a pressed button
To change the style of a button in the pressed state, add the .pressed selector for the button and provide the desired style attributes for it:
<style scoped>
/* styling the button in the pressed state */
.demo-box :deep(button.pressed){
background-color: lightgrey;
color:white;
}
</style>
Here's how the stylized Two State button looks like:
Adding icons into buttons
You can add icons into a Two State button to fit your needs. The name of a default icon starts with the wxi- prefix. Here's an example of using icons in different types of Two State buttons, both with and without text:
<!-- an icon button with a text -->
<TwoState icon="wxi-alert">With Icon</TwoState>
<TwoState type="primary" icon="wxi-alert" iconActive="wxi-check">With Icon</TwoState>
<TwoState type="secondary" icon="wxi-alert">With Icon</TwoState>
<!-- an icon button without a text -->
<TwoState icon="wxi-alert" />
<TwoState type="primary" icon="wxi-alert" />
<TwoState type="secondary" icon="wxi-alert" />
<TwoState type="danger" icon="wxi-alert" />
<!-- a disabled icon button -->
<TwoState disabled icon="wxi-alert" />
![]()
Using the default icon pack
The default icons' set is based on the Material Design icons' collection. The list of predefined icons is presented in the snippet. This list is being constantly replenished with new icons.
To use the default icons' pack on a page, you need:
- include the pack on the page as in:
<link rel="stylesheet" href="https://cdn.svar.dev/fonts/wxi/wx-icons.css" />
- use the
iconproperty to specify the name of the desired icon. The name of a default icon is formed as wxi-name. The button in the example below gets an alert icon:
<TwoState icon="wxi-alert">Click Me</TwoState>
Related sample: Two State Button
Setting an icon for the pressed state
Besides the icon for the default state, Two State Button can have a special icon for the pressed state. Use the iconActive property to set an icon for a Two State button in the pressed state. The example below shows how you can add icons for both states of a button:
<TwoState
icon="wxi-alert"
iconActive="wxi-check">
With Icon
</TwoState>
Related sample: Two State Button
Customizing the appearance of an icon
If necessary, you can change the appearance of an icon by wrapping it in the <i> tag and using its style attribute. For example:
<TwoState type="primary">
<i class="wxi-alert" style="color:yellow;"/>
With Icon
</TwoState>

Two State Button
The Two State Button control is a special button variation that has two states: unpressed and pressed. You can add a click handler for a button, change the button's state, provide separate content for the pressed and unpressed states, set an appropriate button's type and make a button disabled whenever you need it.
Related resources
- Get the widget by installing the
@svar-ui/svelte-corepackage. - Check Two State Button API Reference to see the list of configuration properties.
- Explore the samples to visualize the available features.
Initialization
To create an instance of the Two State button on a page, you need to complete the following steps:
- import the source file of the control on a page:
<script>
import { TwoState } from "@svar-ui/svelte-core";
</script>
- use the
<TwoState>tag to initialize the control:
<TwoState>Click Me</TwoState>
Setting the value
By default, Two State button is initialized in the unpressed state. To enable the pressed state of the button, you should set the value property to true:
<TwoState value={true}>
Click me
</TwoState>
Setting different content for each state
You can provide different content for the default (unpressed) and the pressed states of Two State button:
- for the unpressed state, specify the
textproperty - for the pressed state, specify the
textActiveproperty
<TwoState text="Click me" textActive="Working..."/>
It is possible to use different icons for both states of the button. Read more in the Using icons section.
Related sample: Two State Button
Getting the current state
It is possible to get the current state of the Two State button. For this, you need:
- specify a variable that will contain the value of the button (it may contain the initial value):
<script>
import { TwoState } from "@svar-ui/svelte-core";
let state = true;
</script>
- bind the variable to the
valueproperty of the control:
<TwoState bind:value={state} />
If the name of the variable matches its value, you can use the shorthand while binding the property:
<script>
import { TwoState } from "@svar-ui/svelte-core";
let value = true;
</script>
<TwoState bind:value />
After that the value assigned to the bound variable will be updated on each change of the button's state.
Catching the change of the button state
In case you need to catch when a button is pressed or unpressed, you can do it by handling the change event. Inside the event you can get the value of the button state in the following way:
<script>
function handleChange({value}){
console.log(value);
}
</script>
<TwoState onchange={handleChange}/>
The handler function of the change event takes an object with the state of a button which is "true" (pressed) or "false" (unpressed).
Specifying the appearance of a button
You can specify the desired look and feel of a Two State button by setting the corresponding type. The type of the Two State button is defined by the type property.
<TwoState type={'primary'}>Click Me</TwoState>
The Two State Button control inherits its types from SVAR Button. The list below provides the available types of the Two State Button.
'default'
'primary'
'secondary'
'danger'
'link'(can have an icon and be disabled as well as a standard button)
Related sample: Two State Button
Using a button block
There is a special button type that you can use if you need a button to span the full width of its parent. It is called a button block and has two sub-types:
'primary block'(has the primary styling)
'secondary block'(has the secondary styling)
Related sample: Two State Button
Handling a button click
To add a click handler function to your button, make use of the click event.
<script>
function myFunction() {
// some custom logic
}
</script>
<TwoState onclick={myFunction}>Click Me</TwoState>
Showing a message on click
SVAR provides an extended messaging system to implement user-app communication. Since one of the most common cases for a button click is a call of a notice or a dialog box, you can use the library helpers to create a suitable message box while handling a Two State button click.
For example, you can use the showNotice() helper to display a message:
<script>
import { TwoState } from "@svar-ui/svelte-core";
import { getContext } from "svelte";
// getting the helper
const { showNotice } = getContext("wx-helpers");
// then add a handler function
function onclick() {
// using the helper to show a message
showNotice({
text: "Two State Button is clicked",
});
}
</script>
<div>
<!-- calling the function on a two state button click -->
<TwoState {onclick}>Click Me</TwoState>
</div>
Related sample: Two State Button
You can read detailed information on Messages in the Guides.
Making a button inactive
You can make a button unclickable, if needed. For this, you need to prevent the default click handling via the click handler. Call the preventDefault() method of the Event interface inside the handler function:
<TwoState onclick={ev => ev.preventDefault()}>
Click me
</TwoState>
Related sample: Two State Button
Setting the disabled state
Whenever you need to render a disabled Two State button, you can do it with the help of the disabled property. You can either set the property to true or use the property name without a value:
<TwoState disabled={true}>
Click me
</TwoState>
It is also possible to specify the disabled property without a value:
<TwoState disabled>Click Me</TwoState>
Related sample: Two State Button
Adding a title
A title is a tooltip text that appears on hovering the mouse cursor over a button and may contain some extra information about the control. Use the title property to add a tooltip for a button:
<TwoState title="Click me and I will change my state">Click Me</TwoState>
Related sample: Two State Button
Styling a button
You can add a custom style to the Two State button control. You need to provide the desired settings in the style section of the application and set the name of the custom class as a value of the css property in the control's tag.
<div class="demo-box">
<TwoState type={'primary'} css="my" onclick>Click Me</TwoState>
</div>
<style>
/* styling the button in the default state */
.demo-box :global(button.my){
background-color: gold;
color:white;
}
</style>
In the above example the style is set as global in order to reach an isolated button control. To make the selector specific for the button, the name of the HTML element ("button") is also set before the class name.
Styling a pressed button
To change the style of a button in the pressed state, add the .pressed selector for the button and provide the desired style attributes for it:
<style>
/* styling the button in the pressed state */
.demo-box :global(button.pressed){
background-color: lightgrey;
color:white;
}
</style>
Here's how the stylized Two State button looks:
Adding icons into buttons
You can add icons into a Two State button to fit your needs. The name of a default icon starts with the wxi- prefix. Here's an example of using icons in different types of Two State buttons, both with and without text:
<!-- an icon button with a text -->
<TwoState icon="wxi-alert">With Icon</TwoState>
<TwoState type={'primary'} icon="wxi-alert" iconActive="wxi-check">With Icon</TwoState>
<TwoState type={'secondary'} icon="wxi-alert">With Icon</TwoState>
<!-- an icon button without a text -->
<TwoState icon="wxi-alert" />
<TwoState type={'primary'} icon="wxi-alert" />
<TwoState type={'secondary'} icon="wxi-alert" />
<TwoState type={'danger'} icon="wxi-alert" />
<!-- a disabled icon button -->
<TwoState disabled icon="wxi-alert" />
![]()
Using the default icon pack
The default icons' set is based on the Material Design icons' collection. The list of predefined icons is presented in the snippet. This list is being constantly replenished with new icons.
To use the default icons' pack on a page, you need:
- include the pack on the page as in:
<link rel="stylesheet" href="https://cdn.svar.dev/fonts/wxi/wx-icons.css" />
- use the
iconproperty to specify the name of the desired icon. The name of a default icon is formed as wxi-name. The button in the example below gets an alert icon:
<TwoState icon="wxi-alert">Click Me</TwoState>
Related sample: Two State Button
Setting an icon for the pressed state
Besides the icon for the default state, Two State Button can have a special icon for the pressed state. Use the iconActive property to set an icon for a Two State button in the pressed state. The example below shows how you can add icons for both states of a button:
<TwoState
icon="wxi-alert"
iconActive="wxi-check">
With Icon
</TwoState>
Related sample: Two State Button
Customizing the appearance of an icon
If necessary, you can change the appearance of an icon by wrapping it in the <i> tag and using its style attribute. For example:
<TwoState type={'primary'}>
<i class={"wxi-alert"} style="color:yellow;"/>
With Icon
</TwoState>